GrailsPluginUtils (Grails 2.4.4)
Date: 2014-10-28

Package: org.codehaus.groovy.grails.plugins

## [Groovy] Class GrailsPluginUtils

- org.codehaus.groovy.grails.plugins.GrailsPluginUtils

- Utility class containing methods that aid in loading and evaluating plug-ins.

  Authors:
    Graeme Rocher
  Since:
    1.0

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `static java.lang.String` | `GRAILS_HOME`
    `static java.lang.String` | `WILDCARD`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `static java.lang.Object` | `clearCaches()` Clears cached resolved resources
    `static Resource[]` | `getArtefactResources(java.lang.String basedir)` All artefact resources (all Groovy files contained within the grails-app directory of plugins or applications).
    `static Resource[]` | `getArtefactResourcesForOne(java.lang.String projectDir)` All artefacts in the given application or plugin directory as Spring resources.
    `static Resource[]` | `getAvailableScripts(java.lang.String grailsHome, java.lang.String pluginDirPath, java.lang.String basedir)` All Gant scripts that are availabe for execution in a Grails application.
    `static Resource` | `getBasePluginDescriptor(java.lang.String basedir)`
    `static Resource` | `getDescriptorForPlugin(Resource pluginDir)` Returns the descriptor location for the given plugin directory.
    `static java.lang.String` | `getGlobalPluginsPath()` The path to the global plugins directory.
    `static java.util.List<Resource>` | `getImplicitPluginDirectories(java.lang.String pluginDirPath = BuildSettingsHolder.settings?.projectPluginsDir?.path)` All plugin directories in both the given path and the global "plugins" directory together.
    `static java.lang.String` | `getLowerVersion(java.lang.String pluginVersion)` Returns the lower version of a Grails version number expression in a plugin
    `static groovy.util.slurpersupport.GPathResult` | `getMetadataForPlugin(java.lang.String pluginName)` Returns XML about the plugin.
    `static groovy.util.slurpersupport.GPathResult` | `getMetadataForPlugin(Resource pluginDir)` Returns XML metadata for the plugin.
    `static java.util.List<java.lang.String>` | `getPluginBaseDirectories(java.lang.String pluginDirPath)` All the known plugin base directories (directories where plugins are installed to).
    `static java.util.List<java.lang.String>` | `getPluginBaseDirectories()` All the known plugin base directories (directories where plugins are installed to).
    `static PluginBuildSettings` | `getPluginBuildSettings(BuildSettings buildSettings = null)` Returns a cached PluginBuildSettings instance.
    `static Resource[]` | `getPluginDescriptors(java.lang.String basedir, java.lang.String pluginsDirPath)` All plug-in descriptors (the root classes that end with *GrailsPlugin.groovy).
    `static Resource` | `getPluginDirForName(java.lang.String pluginName)` Obtains a plugin directory for the given name.
    `static Resource` | `getPluginDirForName(java.lang.String pluginsDirPath, java.lang.String pluginName)` Obtains a plugin directory for the given name.
    `static Resource[]` | `getPluginDirectories()`
    `static Resource[]` | `getPluginDirectories(java.lang.String pluginDirPath)`
    `static Resource[]` | `getPluginI18nDirectories(java.lang.String pluginsDirPath = BuildSettingsHolder.settings?.projectPluginsDir?.path)` All plugin i18n directories.
    `static GrailsPluginInfo[]` | `getPluginInfos(java.lang.String pluginDirPath = BuildSettingsHolder.settings?.projectPluginsDir?.path)` Returns an array of PluginInfo objects
    `static Resource[]` | `getPluginJarFiles(java.lang.String pluginsDirPath)` All plug-in provided JAR files.
    `static Resource[]` | `getPluginLibDirectories(java.lang.String pluginsDirPath)` All plug-in lib directories.
    `static java.lang.String` | `getPluginName(java.lang.Class clazz)` Get the name of the a plugin for a particular class.
    `static Resource[]` | `getPluginResourceBundles(java.lang.String pluginDirPath)` All plugin provided resource bundles.
    `static Resource[]` | `getPluginScripts(java.lang.String pluginDirPath)` Plug-in provided Gant scripts available to a Grails application.
    `static Resource[]` | `getPluginSourceFiles(java.lang.String pluginsDirPath)` All plug-in provided source files (Java and Groovy).
    `static java.lang.String` | `getPluginVersion(java.lang.Class clazz)` Get the version of the a plugin for a particular class.
    `static Resource[]` | `getPluginXmlMetadata(java.lang.String pluginsDirPath)` The Plugin metadata XML files used to describe the plugins provided resources.
    `static GrailsPluginInfo[]` | `getSupportedPluginInfos(java.lang.String pluginDirPath = BuildSettingsHolder.settings?.projectPluginsDir?.path)` Returns only the PluginInfo objects that support the current Environment and BuildScope
    `static java.lang.String` | `getUpperVersion(java.lang.String pluginVersion)` Returns the upper version of a Grails version number expression in a plugin
    `static boolean` | `isGlobalPluginLocation(Resource pluginDir)`
    `static boolean` | `isValidVersion(java.lang.String pluginVersion, java.lang.String requiredVersion)` Check if the required version is a valid for the given plugin version.
    `static boolean` | `isVersionGreaterThan(java.lang.String leftVersion, java.lang.String rightVersion)` Returns true if rightVersion is greater than leftVersion
    `static PluginBuildSettings` | `newPluginBuildSettings(BuildSettings buildSettings = null)` Returns a new PluginBuildSettings instance
    `static java.lang.Object` | `setPluginBuildSettings(PluginBuildSettings settings)`
    `static boolean` | `supportsAtLeastVersion(java.lang.String pluginVersion, java.lang.String requiredVersion)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Property Detail

    - #### static final java.lang.String GRAILS_HOME

    - #### static final java.lang.String WILDCARD

  - ### Method Detail

    - #### static java.lang.Object clearCaches()

      Clears cached resolved resources

    - #### static Resource[] getArtefactResources(java.lang.String basedir)

      All artefact resources (all Groovy files contained within the grails-app directory of plugins or applications).

    - #### static Resource[] getArtefactResourcesForOne(java.lang.String projectDir)

      All artefacts in the given application or plugin directory as Spring resources.

    - #### static Resource[] getAvailableScripts(java.lang.String grailsHome, java.lang.String pluginDirPath, java.lang.String basedir)

      All Gant scripts that are availabe for execution in a Grails application.

    - #### static Resource getBasePluginDescriptor(java.lang.String basedir)

    - #### static Resource getDescriptorForPlugin(Resource pluginDir)

      Returns the descriptor location for the given plugin directory. The descriptor is the Groovy file that ends with *GrailsPlugin.groovy.

    - #### static java.lang.String getGlobalPluginsPath()

      The path to the global plugins directory.

    - #### static java.util.List<Resource> getImplicitPluginDirectories(java.lang.String pluginDirPath = BuildSettingsHolder.settings?.projectPluginsDir?.path)

      All plugin directories in both the given path and the global "plugins" directory together.

    - #### static java.lang.String getLowerVersion(java.lang.String pluginVersion)

      Returns the lower version of a Grails version number expression in a plugin

      deprecated:
        Use GrailsVersionUtils

    - #### static groovy.util.slurpersupport.GPathResult getMetadataForPlugin(java.lang.String pluginName)

      Returns XML about the plugin.

    - #### static groovy.util.slurpersupport.GPathResult getMetadataForPlugin(Resource pluginDir)

      Returns XML metadata for the plugin.

    - #### static java.util.List<java.lang.String> getPluginBaseDirectories(java.lang.String pluginDirPath)

      All the known plugin base directories (directories where plugins are installed to).

    - #### static java.util.List<java.lang.String> getPluginBaseDirectories()

      All the known plugin base directories (directories where plugins are installed to).

    - #### static PluginBuildSettings getPluginBuildSettings(BuildSettings buildSettings = null)

      Returns a cached PluginBuildSettings instance.

    - #### static Resource[] getPluginDescriptors(java.lang.String basedir, java.lang.String pluginsDirPath)

      All plug-in descriptors (the root classes that end with *GrailsPlugin.groovy).

    - #### static Resource getPluginDirForName(java.lang.String pluginName)

      Obtains a plugin directory for the given name.

    - #### static Resource getPluginDirForName(java.lang.String pluginsDirPath, java.lang.String pluginName)

      Obtains a plugin directory for the given name.

    - #### static Resource[] getPluginDirectories()

    - #### static Resource[] getPluginDirectories(java.lang.String pluginDirPath)

    - #### static Resource[] getPluginI18nDirectories(java.lang.String pluginsDirPath = BuildSettingsHolder.settings?.projectPluginsDir?.path)

      All plugin i18n directories.

    - #### static GrailsPluginInfo[] getPluginInfos(java.lang.String pluginDirPath = BuildSettingsHolder.settings?.projectPluginsDir?.path)

      Returns an array of PluginInfo objects

    - #### static Resource[] getPluginJarFiles(java.lang.String pluginsDirPath)

      All plug-in provided JAR files.

    - #### static Resource[] getPluginLibDirectories(java.lang.String pluginsDirPath)

      All plug-in lib directories.

    - #### static java.lang.String getPluginName(java.lang.Class clazz)

      Get the name of the a plugin for a particular class.

      deprecated:
        Use GrailsVersionUtils

    - #### static Resource[] getPluginResourceBundles(java.lang.String pluginDirPath)

      All plugin provided resource bundles.

    - #### static Resource[] getPluginScripts(java.lang.String pluginDirPath)

      Plug-in provided Gant scripts available to a Grails application.

    - #### static Resource[] getPluginSourceFiles(java.lang.String pluginsDirPath)

      All plug-in provided source files (Java and Groovy).

    - #### static java.lang.String getPluginVersion(java.lang.Class clazz)

      Get the version of the a plugin for a particular class.

      deprecated:
        Use GrailsVersionUtils

    - #### static Resource[] getPluginXmlMetadata(java.lang.String pluginsDirPath)

      The Plugin metadata XML files used to describe the plugins provided resources.

    - #### static GrailsPluginInfo[] getSupportedPluginInfos(java.lang.String pluginDirPath = BuildSettingsHolder.settings?.projectPluginsDir?.path)

      Returns only the PluginInfo objects that support the current Environment and BuildScope

      See Also:
        Environment
        BuildScope

    - #### static java.lang.String getUpperVersion(java.lang.String pluginVersion)

      Returns the upper version of a Grails version number expression in a plugin

      deprecated:
        Use GrailsVersionUtils

    - #### static boolean isGlobalPluginLocation(Resource pluginDir)

    - #### static boolean isValidVersion(java.lang.String pluginVersion, java.lang.String requiredVersion)

      Check if the required version is a valid for the given plugin version.

      deprecated:
        Use GrailsVersionUtils
      Parameters:
        `pluginVersion` - The plugin version
        `requiredVersion` - The required version
      Returns:
        true if it is valid

    - #### static boolean isVersionGreaterThan(java.lang.String leftVersion, java.lang.String rightVersion)

      Returns true if rightVersion is greater than leftVersion

      Parameters:
        leftVersion
        rightVersion
      Returns:
        @deprecated Use GrailsVersionUtils

    - #### static PluginBuildSettings newPluginBuildSettings(BuildSettings buildSettings = null)

      Returns a new PluginBuildSettings instance

    - #### static java.lang.Object setPluginBuildSettings(PluginBuildSettings settings)

    - #### static boolean supportsAtLeastVersion(java.lang.String pluginVersion, java.lang.String requiredVersion)